---
title: SVGSVGElement
slug: Web/API/SVGSVGElement
tags:
  - API
  - NeedsExample
  - Reference
  - SVG
  - SVG DOM
---
<div>{{APIRef("SVG")}}</div>

<p>The <strong><code>SVGSVGElement</code></strong> interface provides access to the properties of {{SVGElement("svg")}} elements, as well as methods to manipulate them. This interface contains also various miscellaneous commonly-used utility methods, such as matrix operations and the ability to control the time of redraw on visual rendering devices.</p>

<p>{{InheritanceDiagram(600, 140)}}</p>

<h2 id="Properties">Properties</h2>

<p><em>This interface also inherits properties from its parent, {{domxref("SVGGraphicsElement")}} and also implements the ones from {{domxref("SVGZoomAndPan")}}, {{domxref("SVGFitToViewBox")}}, and {{domxref("WindowEventHandlers")}}.</em></p>

<dl>
	<dt>{{domxref("SVGSVGElement.x")}} {{ReadOnlyInline}}</dt>
	<dd>An {{domxref("SVGAnimatedLength")}} corresponding to the {{SVGAttr("x")}} attribute of the given {{SVGElement("svg")}} element.</dd>
	<dt>{{domxref("SVGSVGElement.y")}} {{ReadOnlyInline}}</dt>
	<dd>An {{domxref("SVGAnimatedLength")}} corresponding to the {{SVGAttr("y")}} attribute of the given {{SVGElement("svg")}} element.</dd>
	<dt>{{domxref("SVGSVGElement.width")}} {{ReadOnlyInline}}</dt>
	<dd>An {{domxref("SVGAnimatedLength")}} corresponding to the {{SVGAttr("width")}} attribute of the given {{SVGElement("svg")}} element.</dd>
	<dt>{{domxref("SVGSVGElement.height")}} {{ReadOnlyInline}}</dt>
	<dd>An {{domxref("SVGAnimatedLength")}} corresponding to the {{SVGAttr("height")}} attribute of the given {{SVGElement("svg")}} element.</dd>
	<dt>{{domxref("SVGSVGElement.contentScriptType")}}</dt>
	<dd>An {{domxref("SVGAnimatedLength")}} corresponding to the {{SVGAttr("contentScriptType")}} attribute of the given {{SVGElement("svg")}} element.</dd>
	<dt>{{domxref("SVGSVGElement.contentStyleType")}}</dt>
	<dd>An {{domxref("SVGAnimatedLength")}} corresponding to the {{SVGAttr("contentStyleType")}} attribute of the given {{SVGElement("svg")}} element.</dd>
	<dt>{{domxref("SVGSVGElement.viewport")}}</dt>
	<dd>An {{domxref("SVGRect")}} containing the position and size of the viewport (implicit or explicit) that corresponds to the given {{SVGElement("svg")}} element. When the browser is actually rendering the content, then the position and size values represent the actual values when rendering. The position and size values are unitless values in the coordinate system of the parent element. If no parent element exists (i.e., {{SVGElement("svg")}} element represents the root of the document tree), if this SVG document is embedded as part of another document (e.g., via the HTML {{HTMLElement("object")}} element), then the position and size are unitless values in the coordinate system of the parent document. (If the parent uses CSS or XSL layout, then unitless values represent pixel units for the current CSS or XSL viewport.)</dd>
	<dt>{{domxref("SVGSVGElement.pixelUnitToMillimeterX")}} {{deprecated_inline}}</dt>
	<dd>A float representing the size of the pixel unit (as defined by CSS2) along the x-axis of the viewport, which represents a unit somewhere in the range of 70dpi to 120dpi, and, on systems that support this, might actually match the characteristics of the target medium. On systems where it is impossible to know the size of a pixel, a suitable default pixel size is provided.</dd>
	<dt>{{domxref("SVGSVGElement.pixelUnitToMillimeterY")}} {{deprecated_inline}}</dt>
	<dd>A float representing the size of a pixel unit along the y-axis of the viewport.</dd>
	<dt>{{domxref("SVGSVGElement.screenPixelToMillimeterX")}} {{deprecated_inline}}</dt>
	<dd>User interface (UI) events in DOM Level 2 indicate the screen positions at which the given UI event occurred. When the browser actually knows the physical size of a "screen unit", this float attribute will express that information; otherwise, user agents will provide a suitable default value (such as <code>.28mm</code>).</dd>
	<dt>{{domxref("SVGSVGElement.screenPixelToMillimeterY")}} {{deprecated_inline}}</dt>
	<dd>Corresponding size of a screen pixel along the y-axis of the viewport.</dd>
	<dt>{{domxref("SVGSVGElement.useCurrentView")}}</dt>
	<dd>The initial view (i.e., before magnification and panning) of the current innermost SVG document fragment can be either the "standard" view, i.e., based on attributes on the {{SVGElement("svg")}} element such as {{SVGAttr("viewBox")}}) or on a "custom" view (i.e., a hyperlink into a particular {{SVGElement("view")}} or other element). If the initial view is the "standard" view, then this attribute is <code>false</code>. If the initial view is a "custom" view, then this attribute is <code>true</code>.</dd>
	<dt>{{domxref("SVGSVGElement.currentView")}}</dt>
	<dd>An {{domxref("SVGViewSpec")}} defining the initial view (i.e., before magnification and panning) of the current innermost SVG document fragment. The meaning depends on the situation: If the initial view was a "standard" view, then:
	<ul>
		<li>the values for {{SVGAttr("viewBox")}}, {{SVGAttr("preserveAspectRatio")}} and {{SVGAttr("zoomAndPan")}} within {{SVGAttr("currentView")}} will match the values for the corresponding DOM attributes that are on <code>SVGSVGElement</code> directly</li>
		<li>the values for {{SVGAttr("transform")}} and {{SVGAttr("viewTarget")}} within {{SVGAttr("currentView")}} will be <code>null</code></li>
	</ul>
	If the initial view was a link into a {{SVGElement("view")}} element, then:

	<ul>
		<li>the values for {{SVGAttr("viewBox")}}, {{SVGAttr("preserveAspectRatio")}} and {{SVGAttr("zoomAndPan")}} within {{SVGAttr("currentView")}} will correspond to the corresponding attributes for the given {{SVGElement("view")}} element</li>
		<li>the values for {{SVGAttr("transform")}} and {{SVGAttr("viewTarget")}} within {{SVGAttr("currentView")}} will be <code>null</code></li>
	</ul>
	If the initial view was a link into another element (i.e., other than a {{SVGElement("view")}}), then:

	<ul>
		<li>the values for {{SVGAttr("viewBox")}}, {{SVGAttr("preserveAspectRatio")}} and {{SVGAttr("zoomAndPan")}} within {{SVGAttr("currentView")}} will match the values for the corresponding DOM attributes that are on <code>SVGSVGElement</code> directly for the closest ancestor {{SVGElement("svg")}} element</li>
		<li>the values for {{SVGAttr("transform")}} within {{SVGAttr("currentView")}} will be <code>null</code></li>
		<li>the {{SVGAttr("viewTarget")}} within {{SVGAttr("currentView")}} will represent the target of the link</li>
	</ul>
	If the initial view was a link into the SVG document fragment using an SVG view specification fragment identifier (i.e., <code>#svgView(…)</code>), then:

	<ul>
		<li>the values for {{SVGAttr("viewBox")}}, {{SVGAttr("preserveAspectRatio")}}, {{SVGAttr("zoomAndPan")}}, {{SVGAttr("transform")}} and {{SVGAttr("viewTarget")}} within {{SVGAttr("currentView")}} will correspond to the values from the SVG view specification fragment identifier</li>
	</ul>
	</dd>
	<dt>{{domxref("SVGSVGElement.currentScale")}}</dt>
	<dd>On an outermost {{SVGElement("svg")}} element, this float attribute indicates the current scale factor relative to the initial view to take into account user magnification and panning operations. DOM attributes <code>currentScale</code> and <code>currentTranslate</code> are equivalent to the 2×3 matrix <code>[a b c d e f] = [<var>currentScale</var> 0 0 <var>currentScale</var> <var>currentTranslate</var>.x <var>currentTranslate</var>.y]</code>. If "magnification" is enabled (i.e., <code>zoomAndPan="magnify"</code>), then the effect is as if an extra transformation were placed at the outermost level on the SVG document fragment (i.e., outside the outermost {{SVGElement("svg")}} element).</dd>
	<dt>{{domxref("SVGSVGElement.currentTranslate")}} {{ReadOnlyInline}}</dt>
	<dd>An {{domxref("SVGPoint")}} representing the translation factor that takes into account user "magnification" corresponding to an outermost {{SVGElement("svg")}} element. The behavior is undefined for <code>&lt;svg&gt;</code> elements that are not at the outermost level.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface also inherits methods from its parent, {{domxref("SVGGraphicsElement")}} and also implements the ones from {{domxref("SVGZoomAndPan")}}, {{domxref("SVGFitToViewBox")}}, and {{domxref("WindowEventHandlers")}}.</em></p>

<dl>
	<dt>{{domxref("SVGSVGElement.suspendRedraw()")}} {{deprecated_inline}}</dt>
	<dd>
	<p>Takes a time-out value which indicates that redraw shall not occur until:</p>
	the corresponding <code>unsuspendRedraw()</code> call has been made, an <code>unsuspendRedrawAll()</code> call has been made, or its timer has timed out.

	<p>In environments that do not support interactivity (e.g., print media), then redraw shall not be suspended. Calls to <code>suspendRedraw()</code> and <code>unsuspendRedraw()</code> should, but need not be, made in balanced pairs.</p>

	<p>To suspend redraw actions as a collection of SVG DOM changes occur, precede the changes to the SVG DOM with a method call similar to:</p>

	<pre class="brush: js">const suspendHandleID = suspendRedraw(<var>maxWaitMilliseconds</var>)</pre>

	<p>and follow the changes with a method call similar to:</p>

	<pre class="brush: js">unsuspendRedraw(<var>suspendHandleID</var>)</pre>

	<p>Note that multiple <code>suspendRedraw()</code> calls can be used at once, and that each such method call is treated independently of the other <code>suspendRedraw()</code> method calls.</p>
	</dd>
	<dt>{{domxref("SVGSVGElement.unsuspendRedraw()")}} {{deprecated_inline}}</dt>
	<dd>Cancels a specified <code>suspendRedraw()</code> by providing a unique suspend handle ID that was returned by a previous <code>suspendRedraw()</code> call.</dd>
	<dt>{{domxref("SVGSVGElement.unsuspendRedrawAll()")}} {{deprecated_inline}}</dt>
	<dd>Cancels all currently active <code>suspendRedraw()</code> method calls. This method is most useful at the very end of a set of SVG DOM calls to ensure that all pending <code>suspendRedraw()</code> method calls have been cancelled.</dd>
	<dt>{{domxref("SVGSVGElement.forceRedraw()")}} {{deprecated_inline}}</dt>
	<dd>In rendering environments supporting interactivity, forces the user agent to immediately redraw all regions of the viewport that require updating.</dd>
	<dt>{{domxref("SVGSVGElement.pauseAnimations()")}}</dt>
	<dd>Suspends (i.e., pauses) all currently running animations that are defined within the SVG document fragment corresponding to this {{SVGElement("svg")}} element, causing the animation clock corresponding to this document fragment to stand still until it is unpaused.</dd>
	<dt>{{domxref("SVGSVGElement.unpauseAnimations()")}}</dt>
	<dd>Unsuspends (i.e., unpauses) currently running animations that are defined within the SVG document fragment, causing the animation clock to continue from the time at which it was suspended.</dd>
	<dt>{{domxref("SVGSVGElement.animationsPaused()")}}</dt>
	<dd>Returns <code>true</code> if this SVG document fragment is in a paused state.</dd>
	<dt>{{domxref("SVGSVGElement.getCurrentTime()")}}</dt>
	<dd>Returns the current time in seconds relative to the start time for the current SVG document fragment. If <code>getCurrentTime()</code> is called before the document timeline has begun (for example, by script running in a {{SVGElement("script")}} element before the document's <code>SVGLoad</code> event is dispatched), then <code>0</code> is returned.</dd>
	<dt>{{domxref("SVGSVGElement.setCurrentTime()")}}</dt>
	<dd>Adjusts the clock for this SVG document fragment, establishing a new current time. If <code>setCurrentTime()</code> is called before the document timeline has begun (for example, by script running in a {{SVGElement("script")}} element before the document's <code>SVGLoad</code> event is dispatched), then the value of seconds in the last invocation of the method gives the time that the document will seek to once the document timeline has begun.</dd>
	<dt>{{domxref("SVGSVGElement.getIntersectionList()")}}</dt>
	<dd>Returns a {{domxref("NodeList")}} of graphics elements whose rendered content intersects the supplied rectangle. Each candidate graphics element is to be considered a match only if the same graphics element can be a target of pointer events as defined in {{SVGAttr("pointer-events")}} processing.</dd>
	<dt>{{domxref("SVGSVGElement.getEnclosureList()")}}</dt>
	<dd>Returns a {{domxref("NodeList")}} of graphics elements whose rendered content is entirely contained within the supplied rectangle. Each candidate graphics element is to be considered a match only if the same graphics element can be a target of pointer events as defined in {{SVGAttr("pointer-events")}} processing.</dd>
	<dt>{{domxref("SVGSVGElement.checkIntersection()")}}</dt>
	<dd>Returns <code>true</code> if the rendered content of the given element intersects the supplied rectangle. Each candidate graphics element is to be considered a match only if the same graphics element can be a target of pointer events as defined in {{SVGAttr("pointer-events")}} processing.</dd>
	<dt>{{domxref("SVGSVGElement.checkEnclosure()")}}</dt>
	<dd>Returns <code>true</code> if the rendered content of the given element is entirely contained within the supplied rectangle. Each candidate graphics element is to be considered a match only if the same graphics element can be a target of pointer events as defined in {{SVGAttr("pointer-events")}} processing.</dd>
	<dt>{{domxref("SVGSVGElement.deselectAll()")}}</dt>
	<dd>Unselects any selected objects, including any selections of text strings and type-in bars.</dd>
	<dt>{{domxref("SVGSVGElement.createSVGNumber()")}}</dt>
	<dd>Creates an {{domxref("SVGNumber")}} object outside of any document trees. The object is initialized to <code>0</code>.</dd>
	<dt>{{domxref("SVGSVGElement.createSVGLength()")}}</dt>
	<dd>Creates an {{domxref("SVGLength")}} object outside of any document trees. The object is initialized to <code>0</code> user units.</dd>
	<dt>{{domxref("SVGSVGElement.createSVGAngle()")}}</dt>
	<dd>Creates an {{domxref("SVGAngle")}} object outside of any document trees. The object is initialized to a value of <code>0</code> degrees (unitless).</dd>
	<dt>{{domxref("SVGSVGElement.createSVGPoint()")}}</dt>
	<dd>Creates an {{domxref("SVGPoint")}} object outside of any document trees. The object is initialized to the point <code>(0,0)</code> in the user coordinate system.</dd>
	<dt>{{domxref("SVGSVGElement.createSVGMatrix()")}}</dt>
	<dd>Creates an {{domxref("SVGMatrix")}} object outside of any document trees. The object is initialized to the identity matrix.</dd>
	<dt>{{domxref("SVGSVGElement.createSVGRect()")}}</dt>
	<dd>Creates an {{domxref("SVGRect")}} object outside of any document trees. The object is initialized such that all values are set to <code>0</code> user units.</dd>
	<dt>{{domxref("SVGSVGElement.createSVGTransform()")}}</dt>
	<dd>Creates an {{domxref("SVGTransform")}} object outside of any document trees. The object is initialized to an identity matrix transform (<code>SVG_TRANSFORM_MATRIX</code>).</dd>
	<dt>{{domxref("SVGSVGElement.createSVGTransformFromMatrix()")}}</dt>
	<dd>Creates an {{domxref("SVGTransform")}} object outside of any document trees. The object is initialized to the given matrix transform (i.e., <code>SVG_TRANSFORM_MATRIX</code>). The values from the parameter matrix are copied, the matrix parameter is not adopted as <code>SVGTransform::matrix</code>.</dd>
	<dt>{{domxref("SVGSVGElement.getElementById()")}}</dt>
	<dd>Searches this SVG document fragment (i.e., the search is restricted to a subset of the document tree) for an Element whose <code>id</code> is given by <code><var>elementId</var></code>. If an Element is found, that Element is returned. If no such element exists, returns <code>null</code>. Behavior is not defined if more than one element has this id.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("SVG2", "struct.html#InterfaceSVGSVGElement", "SVGSVGElement")}}</td>
			<td>{{Spec2("SVG2")}}</td>
			<td>Replaced the inheritance from {{domxref("SVGElement")}} by {{domxref("SVGGraphicsElement")}}, removed the implemented interfaces {{domxref("SVGTests")}}, {{domxref("SVGLangSpace")}}, {{domxref("SVGExternalResourcesRequired")}}, {{domxref("SVGStylable")}}, {{domxref("SVGLocatable")}}, {{domxref("DocumentEvent")}}, {{domxref("ViewCSS")}}, and {{domxref("DocumentCSS")}} and added implemented interface {{domxref("WindowEventHandlers")}}.</td>
		</tr>
		<tr>
			<td>{{SpecName("SVG1.1", "struct.html#InterfaceSVGSVGElement", "SVGSVGElement")}}</td>
			<td>{{Spec2("SVG1.1")}}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.SVGSVGElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{SVGElement("circle")}}</li>
</ul>
